#!/usr/bin/env python

import signal

import pianohat
import socket
import sys
import time
import os

svr = socket.socket(socket.AF_INET, socket.SOCK_STREAM)

try:
	svr.bind(('', 1501))
except socket.error as msg:
	print 'Bind failed : '+str(msg)
	sys.exit(-1)


svr.listen(1)

pianohat.auto_leds(True)
conn = None

def sendClient(msg):
    global conn
    if not conn:
        print msg, ' No client'
        return
    print msg
    conn.send(msg+"\n")

def handle_touch(channel, pressed):
    sevt = 't %s %s'%(channel, pressed)
    sendClient(sevt)

def handle_octave_up(channel, pressed):
    sevt = 'O %s %s'%(channel, pressed)
    sendClient(sevt)

def handle_octave_down(channel, pressed):
    sevt = 'o %s %s'%(channel, pressed)
    sendClient(sevt)

def handle_instrument(channel, pressed):
    sevt = 'i %s %s'%(channel, pressed)
    sendClient(sevt)

pianohat.on_note(handle_touch)
pianohat.on_octave_up(handle_octave_up)
pianohat.on_octave_down(handle_octave_down)
pianohat.on_instrument(handle_instrument)

try:
    while True:
        print 'Waiting for connection...'
        conn, addr = svr.accept()
        print 'Client Connected!'
        while conn is not None:
            cmd = conn.recv(2)
            if len(cmd)==0:
                break
        print 'Client Disconnected!'
        conn.close()
        conn = None
except:
      pass

print '\nExiting...'
svr.close()
sys.exit(-1)
